/* Generated By:JavaCC: Do not edit this line. JavaCCGeneratedQueryParser.java */
package org.apache.clerezza.rdf.core.sparql;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.apache.clerezza.rdf.core.BNode;
import org.apache.clerezza.rdf.core.Language;
import org.apache.clerezza.rdf.core.Literal;
import org.apache.clerezza.rdf.core.LiteralFactory;
import org.apache.clerezza.rdf.core.Resource;
import org.apache.clerezza.rdf.core.TypedLiteral;
import org.apache.clerezza.rdf.core.UriRef;
import org.apache.clerezza.rdf.core.impl.PlainLiteralImpl;
import org.apache.clerezza.rdf.core.impl.TypedLiteralImpl;
import org.apache.clerezza.rdf.core.sparql.query.GroupGraphPattern;
import org.apache.clerezza.rdf.core.sparql.query.BinaryOperation;
import org.apache.clerezza.rdf.core.sparql.query.Variable;
import org.apache.clerezza.rdf.core.sparql.query.ResourceOrVariable;
import org.apache.clerezza.rdf.core.sparql.query.UriRefOrVariable;
import org.apache.clerezza.rdf.core.sparql.query.FunctionCall;
import org.apache.clerezza.rdf.core.sparql.query.TriplePattern;
import org.apache.clerezza.rdf.core.sparql.query.Query;
import org.apache.clerezza.rdf.core.sparql.query.LiteralExpression;
import org.apache.clerezza.rdf.core.sparql.query.AlternativeGraphPattern;
import org.apache.clerezza.rdf.core.sparql.query.BuiltInCall;
import org.apache.clerezza.rdf.core.sparql.query.Expression;
import org.apache.clerezza.rdf.core.sparql.query.UriRefExpression;
import org.apache.clerezza.rdf.core.sparql.query.UnaryOperation;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleAlternativeGraphPattern;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleAskQuery;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleConstructQuery;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleDescribeQuery;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleGraphGraphPattern;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleGroupGraphPattern;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleOrderCondition;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleQuery;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleQueryWithSolutionModifier;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleSelectQuery;
import org.apache.clerezza.rdf.core.sparql.query.impl.SimpleTriplePattern;

/**
 *
 * Credits: Fedora Commons, Inc.
 *            - for initial grammar of this file (available in mulgara project).
 * Modified by: Hasan <hasan@trialox.org>
 */
class JavaCCGeneratedQueryParser implements JavaCCGeneratedQueryParserConstants {

        private static final UriRef RDF_TYPE =
                new UriRef("http://www.w3.org/1999/02/22-rdf-syntax-ns#type");
        private static final UriRef RDF_FIRST =
                new UriRef("http://www.w3.org/1999/02/22-rdf-syntax-ns#first");
        private static final UriRef RDF_REST =
                new UriRef("http://www.w3.org/1999/02/22-rdf-syntax-ns#rest");
        private static final UriRef RDF_NIL =
                new UriRef("http://www.w3.org/1999/02/22-rdf-syntax-ns#nil");

        /** A RegEx pattern for separating out a namespace from a prefixed name. */
        private static final Pattern pfxNamePattern = Pattern.compile("([^:]*):(.*)");

        private Query query;
        private String base;
        private Map<String, String> prefixes;
        private Map<String, ResourceOrVariable> bNodes;
        private int count;
        private Map<String, Variable> vars;

        void initialize() {
                query = null;
                base = null;
                prefixes = new HashMap<String, String>();
                bNodes = new HashMap<String, ResourceOrVariable>();
                count = 0;
                vars = new HashMap<String, Variable>();
        }

        Query parse() throws ParseException {
                initialize();
                this.Query();
                return this.query;
        }

        private static String unquote(String s) {
                return s.substring(1, s.length() - 1);
        }

        private static String unTripleQuote(String s) {
                return s.substring(3, s.length() - 3);
        }

        private Variable getVariable(String name) {
                name = name.substring(1);
                Variable v = vars.get(name);
                if (v == null) {
                        v = new Variable(name);
                        vars.put(name, v);
                        if (query instanceof SimpleSelectQuery) {
                                SimpleSelectQuery sq = (SimpleSelectQuery) query;
                                if (sq.isSelectAll()) {
                                        sq.addSelection(v);
                                }
                        } else if (query instanceof SimpleDescribeQuery) {
                                SimpleDescribeQuery dq = (SimpleDescribeQuery) query;
                                if (dq.isDescribeAll()) {
                                        dq.addResourceToDescribe(new ResourceOrVariable(v));
                                }
                        }
                }
                return v;
        }

        private void addTriplePatterns(Set<TriplePattern> triplePatterns,
                        ResourceOrVariable subject,
                        UriRefOrVariable predicate,
                        Set<ResourceOrVariable> objects) {

                for (ResourceOrVariable object : objects) {
                        triplePatterns.add(
                                new SimpleTriplePattern(subject, predicate, object));
                }
        }

        // nodes contain at least one element
        private ResourceOrVariable addTriplePatterns(
                        Set<TriplePattern> triplePatterns,
                        List<ResourceOrVariable> nodes) {

                ResourceOrVariable head = null;
                UriRefOrVariable rdfFirst = new UriRefOrVariable(RDF_FIRST);
                UriRefOrVariable rdfRest = new UriRefOrVariable(RDF_REST);
                UriRefOrVariable rdfNil = new UriRefOrVariable(RDF_NIL);

                ResourceOrVariable prevSubject = null;
                for (ResourceOrVariable node : nodes) {
                        ResourceOrVariable currentSubject = getNewBNode();
                        if (prevSubject != null) {
                                triplePatterns.add(
                                        new SimpleTriplePattern(prevSubject, rdfRest, currentSubject));
                        } else {
                                head = currentSubject;
                        }
                        triplePatterns.add(
                                new SimpleTriplePattern(currentSubject, rdfFirst, node));
                        prevSubject = currentSubject;
                }
                if (prevSubject != null) {
                        triplePatterns.add(
                                new SimpleTriplePattern(prevSubject, rdfRest, rdfNil));
                }
                return head;
        }

        private ResourceOrVariable getNewBNode() {
                ResourceOrVariable bNode = new ResourceOrVariable(new BNode());
                bNodes.put("*" + count++, bNode);
                return bNode;
        }

        private ResourceOrVariable getBNode(String label) {
                ResourceOrVariable bNode = bNodes.get(label);
                if (bNode == null) {
                        bNode = new ResourceOrVariable(new BNode());
                        bNodes.put(label, bNode);
                }
                return bNode;
        }

        private UriRef createUriRef(String r) throws ParseException {
                // Create an IRI directly if the string does not start with a prefix
                Matcher m = pfxNamePattern.matcher(r);
                if (!m.matches()) {
                        // either a normal IRI, or one with a BASE
                        return isRelative(r) ? new UriRef(base + r) : new UriRef(r);
                }
                // extract the prefix, and attempt to convert to a URI before creating the reference
                String ns = prefixes.get(m.group(1));
                return ns == null ? new UriRef(r) : new UriRef(ns + m.group(2));
        }

        /**
	 * Tests if the string for a URI is relative or absolute. The test is based on a scheme existing
	 * in the string, which in turn expects a : character to follow it. If there is no colon, then
	 * it is presumed to be relative. Otherwise, if there are special characters preceding the first
	 * colon these are presumed to not be in a scheme.
	 * @param u A string for a URI.
	 * @return <code>true</code> if the URI appears to be relative, <code>false</code> otherwise.
	 */
        private static boolean isRelative(String u) {
                int colon = u.indexOf(':');
                if (colon < 0) {
                        return true;
                }
                for (int c = 0; c < colon; c++) {
                        // if there a non-alphanum characters then this is not a scheme, so the URI is relative
                        if (!Character.isLetterOrDigit(u.charAt(c))) {
                                return true;
                        }
                }
                // found a (probably) valid scheme, so the URI is absolute
                return false;
        }

  final private void Query() throws ParseException {
    Prologue();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SELECT:
      SelectQuery();
      break;
    case CONSTRUCT:
      ConstructQuery();
      break;
    case DESCRIBE:
      DescribeQuery();
      break;
    case ASK:
      AskQuery();
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(0);
  }

  final private void Prologue() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BASE:
      BaseDecl();
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PREFIX:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_1;
      }
      PrefixDecl();
    }
  }

  final private void BaseDecl() throws ParseException {
        Token iriRef;
    jj_consume_token(BASE);
    iriRef = jj_consume_token(IRI_REF);
                                  base = unquote(iriRef.image);
  }

  final private void PrefixDecl() throws ParseException {
        Token ns, iriRef;
    jj_consume_token(PREFIX);
    ns = jj_consume_token(PNAME_NS);
    iriRef = jj_consume_token(IRI_REF);
        String pfx = ns.image;
        prefixes.put(pfx.substring(0, pfx.length() - 1), unquote(iriRef.image));
  }

  final private void SelectQuery() throws ParseException {
        Variable v;
    jj_consume_token(SELECT);
        query = new SimpleSelectQuery();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DISTINCT:
    case REDUCED:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DISTINCT:
        jj_consume_token(DISTINCT);
                ((SimpleSelectQuery) query).setDistinct();
        break;
      case REDUCED:
        jj_consume_token(REDUCED);
                ((SimpleSelectQuery) query).setReduced();
        break;
      default:
        jj_la1[3] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[4] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR1:
    case VAR2:
      label_2:
      while (true) {
        v = Var();
                        ((SimpleSelectQuery) query).addSelection(v);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case VAR1:
        case VAR2:
          ;
          break;
        default:
          jj_la1[5] = jj_gen;
          break label_2;
        }
      }
      break;
    case 40:
      jj_consume_token(40);
                        ((SimpleSelectQuery) query).setSelectAll();
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FROM:
        ;
        break;
      default:
        jj_la1[7] = jj_gen;
        break label_3;
      }
      DatasetClause();
    }
    WhereClause();
    SolutionModifier();
  }

  final private void ConstructQuery() throws ParseException {
        Set<TriplePattern> triplePatterns = null;
    jj_consume_token(CONSTRUCT);
    triplePatterns = ConstructTemplate();
        query = new SimpleConstructQuery(triplePatterns);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FROM:
        ;
        break;
      default:
        jj_la1[8] = jj_gen;
        break label_4;
      }
      DatasetClause();
    }
    WhereClause();
    SolutionModifier();
  }

  final private void DescribeQuery() throws ParseException {
        UriRefOrVariable node;
    jj_consume_token(DESCRIBE);
        query = new SimpleDescribeQuery();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case VAR1:
    case VAR2:
      label_5:
      while (true) {
        node = VarOrIRIref();
                        ((SimpleDescribeQuery) query).addResourceToDescribe(node);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IRI_REF:
        case PNAME_NS:
        case PNAME_LN:
        case VAR1:
        case VAR2:
          ;
          break;
        default:
          jj_la1[9] = jj_gen;
          break label_5;
        }
      }
      break;
    case 40:
      jj_consume_token(40);
                        ((SimpleDescribeQuery) query).setDescribeAll();
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FROM:
        ;
        break;
      default:
        jj_la1[11] = jj_gen;
        break label_6;
      }
      DatasetClause();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WHERE:
    case 43:
      WhereClause();
      break;
    default:
      jj_la1[12] = jj_gen;
      ;
    }
    SolutionModifier();
  }

  final private void AskQuery() throws ParseException {
    jj_consume_token(ASK);
        query = new SimpleAskQuery();
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FROM:
        ;
        break;
      default:
        jj_la1[13] = jj_gen;
        break label_7;
      }
      DatasetClause();
    }
    WhereClause();
  }

  final private void DatasetClause() throws ParseException {
    jj_consume_token(FROM);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
      DefaultGraphClause();
      break;
    case NAMED:
      NamedGraphClause();
      break;
    default:
      jj_la1[14] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final private void DefaultGraphClause() throws ParseException {
        UriRef defaultGraph;
    defaultGraph = SourceSelector();
        ((SimpleQuery) query).addDefaultGraph(defaultGraph);
  }

  final private void NamedGraphClause() throws ParseException {
        UriRef namedGraph;
    jj_consume_token(NAMED);
    namedGraph = SourceSelector();
        ((SimpleQuery) query).addNamedGraph(namedGraph);
  }

  final private UriRef SourceSelector() throws ParseException {
        UriRef graph;
    graph = IRIref();
        {if (true) return graph;}
    throw new Error("Missing return statement in function");
  }

  final private void WhereClause() throws ParseException {
        GroupGraphPattern queryPattern;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WHERE:
      jj_consume_token(WHERE);
      break;
    default:
      jj_la1[15] = jj_gen;
      ;
    }
    queryPattern = GroupGraphPattern();
        ((SimpleQuery) query).setQueryPattern(queryPattern);
  }

  final private void SolutionModifier() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ORDER:
      OrderClause();
      break;
    default:
      jj_la1[16] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LIMIT:
    case OFFSET:
      LimitOffsetClauses();
      break;
    default:
      jj_la1[17] = jj_gen;
      ;
    }
  }

  final private void LimitOffsetClauses() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LIMIT:
      LimitClause();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OFFSET:
        OffsetClause();
        break;
      default:
        jj_la1[18] = jj_gen;
        ;
      }
      break;
    case OFFSET:
      OffsetClause();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LIMIT:
        LimitClause();
        break;
      default:
        jj_la1[19] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[20] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final private void OrderClause() throws ParseException {
    jj_consume_token(ORDER);
    jj_consume_token(BY);
    label_8:
    while (true) {
      OrderCondition();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STR:
      case IS_URI:
      case LANG:
      case IS_IRI:
      case LANGMATCHES:
      case IS_BLANK:
      case IS_LITERAL:
      case DATATYPE:
      case REGEX:
      case BOUND:
      case SAME_TERM:
      case 41:
      case 42:
      case 46:
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case VAR1:
      case VAR2:
        ;
        break;
      default:
        jj_la1[21] = jj_gen;
        break label_8;
      }
    }
  }

  final private void OrderCondition() throws ParseException {
        boolean asc = true;
        Expression e;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 41:
    case 42:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 41:
        jj_consume_token(41);
        break;
      case 42:
        jj_consume_token(42);
                                     asc = false;
        break;
      default:
        jj_la1[22] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      e = BrackettedExpression();
      break;
    case STR:
    case IS_URI:
    case LANG:
    case IS_IRI:
    case LANGMATCHES:
    case IS_BLANK:
    case IS_LITERAL:
    case DATATYPE:
    case REGEX:
    case BOUND:
    case SAME_TERM:
    case 46:
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case VAR1:
    case VAR2:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STR:
      case IS_URI:
      case LANG:
      case IS_IRI:
      case LANGMATCHES:
      case IS_BLANK:
      case IS_LITERAL:
      case DATATYPE:
      case REGEX:
      case BOUND:
      case SAME_TERM:
      case 46:
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
        e = Constraint();
        break;
      case VAR1:
      case VAR2:
        e = Var();
        break;
      default:
        jj_la1[23] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[24] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        ((SimpleQueryWithSolutionModifier) query).addOrderCondition(new SimpleOrderCondition(e, asc));
  }

  final private void LimitClause() throws ParseException {
        Token t;
    jj_consume_token(LIMIT);
    t = jj_consume_token(INTEGER);
        ((SimpleQueryWithSolutionModifier) query).setLimit(Integer.parseInt(t.image));
  }

  final private void OffsetClause() throws ParseException {
        Token t;
    jj_consume_token(OFFSET);
    t = jj_consume_token(INTEGER);
        ((SimpleQueryWithSolutionModifier) query).setOffset(Integer.parseInt(t.image));
  }

  final private GroupGraphPattern GroupGraphPattern() throws ParseException {
        GroupGraphPattern groupGraphPattern = new SimpleGroupGraphPattern();
        Expression constraint;
    jj_consume_token(43);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
    case FALSE:
    case 46:
    case 51:
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case BLANK_NODE_LABEL:
    case VAR1:
    case VAR2:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case NIL:
    case ANON:
      TriplesBlock(groupGraphPattern);
      break;
    default:
      jj_la1[25] = jj_gen;
      ;
    }
    label_9:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GRAPH:
      case OPTIONAL:
      case FILTER:
      case 43:
        ;
        break;
      default:
        jj_la1[26] = jj_gen;
        break label_9;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GRAPH:
      case OPTIONAL:
      case 43:
        GraphPatternNotTriples(groupGraphPattern);
        break;
      case FILTER:
        constraint = Filter();
                ((SimpleGroupGraphPattern) groupGraphPattern).addConstraint(constraint);
        break;
      default:
        jj_la1[27] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 44:
        jj_consume_token(44);
        break;
      default:
        jj_la1[28] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUE:
      case FALSE:
      case 46:
      case 51:
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case BLANK_NODE_LABEL:
      case VAR1:
      case VAR2:
      case INTEGER:
      case DECIMAL:
      case DOUBLE:
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
      case STRING_LITERAL1:
      case STRING_LITERAL2:
      case STRING_LITERAL_LONG1:
      case STRING_LITERAL_LONG2:
      case NIL:
      case ANON:
        TriplesBlock(groupGraphPattern);
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
    }
    jj_consume_token(45);
        {if (true) return groupGraphPattern;}
    throw new Error("Missing return statement in function");
  }

  final private void TriplesBlock(GroupGraphPattern groupGraphPattern) throws ParseException {
        Set<TriplePattern> triplePatterns;
    triplePatterns = TriplesSameSubject();
        ((SimpleGroupGraphPattern) groupGraphPattern).addTriplePatterns(triplePatterns);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 44:
      jj_consume_token(44);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUE:
      case FALSE:
      case 46:
      case 51:
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case BLANK_NODE_LABEL:
      case VAR1:
      case VAR2:
      case INTEGER:
      case DECIMAL:
      case DOUBLE:
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
      case STRING_LITERAL1:
      case STRING_LITERAL2:
      case STRING_LITERAL_LONG1:
      case STRING_LITERAL_LONG2:
      case NIL:
      case ANON:
        TriplesBlock(groupGraphPattern);
        break;
      default:
        jj_la1[30] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[31] = jj_gen;
      ;
    }
  }

  final private void GraphPatternNotTriples(GroupGraphPattern groupGraphPattern) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPTIONAL:
      OptionalGraphPattern(groupGraphPattern);
      break;
    case 43:
      GroupOrUnionGraphPattern(groupGraphPattern);
      break;
    case GRAPH:
      GraphGraphPattern(groupGraphPattern);
      break;
    default:
      jj_la1[32] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final private void OptionalGraphPattern(GroupGraphPattern groupGraphPattern) throws ParseException {
        GroupGraphPattern optional;
    jj_consume_token(OPTIONAL);
    optional = GroupGraphPattern();
        ((SimpleGroupGraphPattern) groupGraphPattern).addOptionalGraphPattern(optional);
  }

  final private void GraphGraphPattern(GroupGraphPattern groupGraphPattern) throws ParseException {
        UriRefOrVariable graph;
        GroupGraphPattern g;
    jj_consume_token(GRAPH);
    graph = VarOrIRIref();
    g = GroupGraphPattern();
        ((SimpleGroupGraphPattern) groupGraphPattern).addGraphPattern(
                new SimpleGraphGraphPattern(graph, g));
  }

  final private void GroupOrUnionGraphPattern(GroupGraphPattern groupGraphPattern) throws ParseException {
        GroupGraphPattern g;
        AlternativeGraphPattern unionGraphPattern = null;
    g = GroupGraphPattern();
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case UNION:
        ;
        break;
      default:
        jj_la1[33] = jj_gen;
        break label_10;
      }
      jj_consume_token(UNION);
                if (unionGraphPattern == null) {
                        unionGraphPattern = new SimpleAlternativeGraphPattern(g);
                }
      g = GroupGraphPattern();
                ((SimpleAlternativeGraphPattern) unionGraphPattern).addAlternativeGraphPattern(g);
    }
        if (unionGraphPattern != null) {
                ((SimpleGroupGraphPattern) groupGraphPattern).addGraphPattern(unionGraphPattern);
        } else {
                ((SimpleGroupGraphPattern) groupGraphPattern).addGraphPattern(g);
        }
  }

  final private Expression Filter() throws ParseException {
        Expression c;
    jj_consume_token(FILTER);
    c = Constraint();
        {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final private Expression Constraint() throws ParseException {
        Expression c;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 46:
      c = BrackettedExpression();
      break;
    case STR:
    case IS_URI:
    case LANG:
    case IS_IRI:
    case LANGMATCHES:
    case IS_BLANK:
    case IS_LITERAL:
    case DATATYPE:
    case REGEX:
    case BOUND:
    case SAME_TERM:
      c = BuiltInCall();
      break;
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
      c = FunctionCall();
      break;
    default:
      jj_la1[34] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final private FunctionCall FunctionCall() throws ParseException {
        UriRef name;
        List<Expression> arguments;
    name = IRIref();
    arguments = ArgList();
        {if (true) return new FunctionCall(name, arguments);}
    throw new Error("Missing return statement in function");
  }

  final private List<Expression> ArgList() throws ParseException {
        List<Expression> args = new ArrayList<Expression>();
        Expression e;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NIL:
      jj_consume_token(NIL);
      break;
    case 46:
      jj_consume_token(46);
      e = Expression();
                        args.add(e);
      label_11:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 47:
          ;
          break;
        default:
          jj_la1[35] = jj_gen;
          break label_11;
        }
        jj_consume_token(47);
        e = Expression();
                                args.add(e);
      }
      jj_consume_token(48);
      break;
    default:
      jj_la1[36] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return args;}
    throw new Error("Missing return statement in function");
  }

  final private Set<TriplePattern> ConstructTemplate() throws ParseException {
        Set<TriplePattern> triplePatterns = null;
    jj_consume_token(43);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
    case FALSE:
    case 46:
    case 51:
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case BLANK_NODE_LABEL:
    case VAR1:
    case VAR2:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case NIL:
    case ANON:
      triplePatterns = ConstructTriples();
      break;
    default:
      jj_la1[37] = jj_gen;
      ;
    }
    jj_consume_token(45);
        {if (true) return triplePatterns;}
    throw new Error("Missing return statement in function");
  }

  final private Set<TriplePattern> ConstructTriples() throws ParseException {
        Set<TriplePattern> triplePatterns, t;
    triplePatterns = TriplesSameSubject();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 44:
      jj_consume_token(44);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUE:
      case FALSE:
      case 46:
      case 51:
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case BLANK_NODE_LABEL:
      case VAR1:
      case VAR2:
      case INTEGER:
      case DECIMAL:
      case DOUBLE:
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
      case STRING_LITERAL1:
      case STRING_LITERAL2:
      case STRING_LITERAL_LONG1:
      case STRING_LITERAL_LONG2:
      case NIL:
      case ANON:
        t = ConstructTriples();
                triplePatterns.addAll(t);
        break;
      default:
        jj_la1[38] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[39] = jj_gen;
      ;
    }
        {if (true) return triplePatterns;}
    throw new Error("Missing return statement in function");
  }

  final private Set<TriplePattern> TriplesSameSubject() throws ParseException {
        Set<TriplePattern> triplePatterns = new HashSet<TriplePattern>();
        ResourceOrVariable subject;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
    case FALSE:
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case BLANK_NODE_LABEL:
    case VAR1:
    case VAR2:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case NIL:
    case ANON:
      subject = VarOrTerm();
      PropertyListNotEmpty(subject, triplePatterns);
                {if (true) return triplePatterns;}
      break;
    case 46:
    case 51:
      subject = TriplesNode(triplePatterns);
      PropertyList(subject, triplePatterns);
                {if (true) return triplePatterns;}
      break;
    default:
      jj_la1[40] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private void PropertyListNotEmpty(ResourceOrVariable subject,
                Set<TriplePattern> triplePatterns) throws ParseException {
        UriRefOrVariable predicate;
        Set<ResourceOrVariable> objects;
    predicate = Verb();
    objects = ObjectList(triplePatterns);
        addTriplePatterns(triplePatterns, subject, predicate, objects);
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 49:
        ;
        break;
      default:
        jj_la1[41] = jj_gen;
        break label_12;
      }
      jj_consume_token(49);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 50:
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case VAR1:
      case VAR2:
        predicate = Verb();
        objects = ObjectList(triplePatterns);
                        addTriplePatterns(triplePatterns, subject, predicate, objects);
        break;
      default:
        jj_la1[42] = jj_gen;
        ;
      }
    }
  }

  final private void PropertyList(ResourceOrVariable subject,
                Set<TriplePattern> triplePatterns) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 50:
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case VAR1:
    case VAR2:
      PropertyListNotEmpty(subject, triplePatterns);
      break;
    default:
      jj_la1[43] = jj_gen;
      ;
    }
  }

  final private Set<ResourceOrVariable> ObjectList(Set<TriplePattern> triplePatterns) throws ParseException {
        ResourceOrVariable object;
        Set<ResourceOrVariable> objects = new HashSet<ResourceOrVariable>();
    object = Object(triplePatterns);
        objects.add(object);
    label_13:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 47:
        ;
        break;
      default:
        jj_la1[44] = jj_gen;
        break label_13;
      }
      jj_consume_token(47);
      object = Object(triplePatterns);
                        objects.add(object);
    }
        {if (true) return objects;}
    throw new Error("Missing return statement in function");
  }

  final private ResourceOrVariable Object(Set<TriplePattern> triplePatterns) throws ParseException {
        ResourceOrVariable object;
    object = GraphNode(triplePatterns);
        {if (true) return object;}
    throw new Error("Missing return statement in function");
  }

  final private UriRefOrVariable Verb() throws ParseException {
        UriRefOrVariable predicate;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case VAR1:
    case VAR2:
      predicate = VarOrIRIref();
        {if (true) return predicate;}
      break;
    case 50:
      jj_consume_token(50);
        {if (true) return new UriRefOrVariable(RDF_TYPE);}
      break;
    default:
      jj_la1[45] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private ResourceOrVariable TriplesNode(Set<TriplePattern> triplePatterns) throws ParseException {
        ResourceOrVariable subject;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 46:
      subject = Collection(triplePatterns);
      break;
    case 51:
      subject = BlankNodePropertyList(triplePatterns);
      break;
    default:
      jj_la1[46] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return subject;}
    throw new Error("Missing return statement in function");
  }

  final private ResourceOrVariable BlankNodePropertyList(Set<TriplePattern> triplePatterns) throws ParseException {
        ResourceOrVariable subject = getNewBNode();
    jj_consume_token(51);
    PropertyListNotEmpty(subject, triplePatterns);
    jj_consume_token(52);
        {if (true) return subject;}
    throw new Error("Missing return statement in function");
  }

  final private ResourceOrVariable Collection(Set<TriplePattern> triplePatterns) throws ParseException {
        ResourceOrVariable node;
        List<ResourceOrVariable> nodes = new ArrayList<ResourceOrVariable>();
    jj_consume_token(46);
    label_14:
    while (true) {
      node = GraphNode(triplePatterns);
                nodes.add(node);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUE:
      case FALSE:
      case 46:
      case 51:
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case BLANK_NODE_LABEL:
      case VAR1:
      case VAR2:
      case INTEGER:
      case DECIMAL:
      case DOUBLE:
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
      case STRING_LITERAL1:
      case STRING_LITERAL2:
      case STRING_LITERAL_LONG1:
      case STRING_LITERAL_LONG2:
      case NIL:
      case ANON:
        ;
        break;
      default:
        jj_la1[47] = jj_gen;
        break label_14;
      }
    }
    jj_consume_token(48);
        {if (true) return addTriplePatterns(triplePatterns, nodes);}
    throw new Error("Missing return statement in function");
  }

  final private ResourceOrVariable GraphNode(Set<TriplePattern> triplePatterns) throws ParseException {
        ResourceOrVariable node;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
    case FALSE:
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case BLANK_NODE_LABEL:
    case VAR1:
    case VAR2:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case NIL:
    case ANON:
      node = VarOrTerm();
      break;
    case 46:
    case 51:
      node = TriplesNode(triplePatterns);
      break;
    default:
      jj_la1[48] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  final private ResourceOrVariable VarOrTerm() throws ParseException {
        ResourceOrVariable r;
        Variable v;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR1:
    case VAR2:
      v = Var();
        {if (true) return new ResourceOrVariable(v);}
      break;
    case TRUE:
    case FALSE:
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case BLANK_NODE_LABEL:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case NIL:
    case ANON:
      r = GraphTerm();
        {if (true) return r;}
      break;
    default:
      jj_la1[49] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private UriRefOrVariable VarOrIRIref() throws ParseException {
        Variable var;
        UriRef uriRef;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR1:
    case VAR2:
      var = Var();
        {if (true) return new UriRefOrVariable(var);}
      break;
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
      uriRef = IRIref();
        {if (true) return new UriRefOrVariable(uriRef);}
      break;
    default:
      jj_la1[50] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private Variable Var() throws ParseException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR1:
      t = jj_consume_token(VAR1);
      break;
    case VAR2:
      t = jj_consume_token(VAR2);
      break;
    default:
      jj_la1[51] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return getVariable(t.image);}
    throw new Error("Missing return statement in function");
  }

  final private ResourceOrVariable GraphTerm() throws ParseException {
        ResourceOrVariable bNode = null;
        Resource r = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
      r = IRIref();
      break;
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
      r = RDFLiteral();
      break;
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
      r = NumericLiteral();
      break;
    case TRUE:
    case FALSE:
      r = BooleanLiteral();
      break;
    case BLANK_NODE_LABEL:
    case ANON:
      bNode = BlankNode();
      break;
    case NIL:
      jj_consume_token(NIL);
                r = RDF_NIL;
      break;
    default:
      jj_la1[52] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        if (bNode == null) {
                {if (true) return new ResourceOrVariable(r);}
        }
        {if (true) return bNode;}
    throw new Error("Missing return statement in function");
  }

  final private Expression Expression() throws ParseException {
        Expression e;
    e = ConditionalOrExpression();
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  final private Expression ConditionalOrExpression() throws ParseException {
        Expression e, ae;
    e = ConditionalAndExpression();
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 53:
        ;
        break;
      default:
        jj_la1[53] = jj_gen;
        break label_15;
      }
      jj_consume_token(53);
      ae = ConditionalAndExpression();
                e = new BinaryOperation("||", e, ae);
    }
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  final private Expression ConditionalAndExpression() throws ParseException {
        Expression e, e2;
    e = ValueLogical();
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 54:
        ;
        break;
      default:
        jj_la1[54] = jj_gen;
        break label_16;
      }
      jj_consume_token(54);
      e2 = ValueLogical();
                e = new BinaryOperation("&&", e, e2);
    }
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  final private Expression ValueLogical() throws ParseException {
        Expression e;
    e = RelationalExpression();
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  final private Expression RelationalExpression() throws ParseException {
        Expression e, e2;
    e = NumericExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 55:
    case 56:
    case 57:
    case 58:
    case 59:
    case 60:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 55:
        jj_consume_token(55);
        e2 = NumericExpression();
                        e = new BinaryOperation("=", e, e2);
        break;
      case 56:
        jj_consume_token(56);
        e2 = NumericExpression();
                        e = new BinaryOperation("!=", e, e2);
        break;
      case 57:
        jj_consume_token(57);
        e2 = NumericExpression();
                        e = new BinaryOperation("<", e, e2);
        break;
      case 58:
        jj_consume_token(58);
        e2 = NumericExpression();
                        e = new BinaryOperation(">", e, e2);
        break;
      case 59:
        jj_consume_token(59);
        e2 = NumericExpression();
                        e = new BinaryOperation("<=", e, e2);
        break;
      case 60:
        jj_consume_token(60);
        e2 = NumericExpression();
                        e = new BinaryOperation(">=", e, e2);
        break;
      default:
        jj_la1[55] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[56] = jj_gen;
      ;
    }
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  final private Expression NumericExpression() throws ParseException {
        Expression e;
    e = AdditiveExpression();
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  final private Expression AdditiveExpression() throws ParseException {
        Expression e, e2;
        TypedLiteral l;
    e = MultiplicativeExpression();
    label_17:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 61:
      case 62:
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
        ;
        break;
      default:
        jj_la1[57] = jj_gen;
        break label_17;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 61:
        jj_consume_token(61);
        e2 = MultiplicativeExpression();
                        e = new BinaryOperation("+", e, e2);
        break;
      case 62:
        jj_consume_token(62);
        e2 = MultiplicativeExpression();
                        e = new BinaryOperation("-", e, e2);
        break;
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
        l = NumericLiteralPositive();
                        e = new BinaryOperation("+", e, new LiteralExpression(l));
        break;
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
        l = NumericLiteralNegative();
                        e = new BinaryOperation("-", e, new LiteralExpression(l));
        break;
      default:
        jj_la1[58] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  final private Expression MultiplicativeExpression() throws ParseException {
        Expression e, e2;
    e = UnaryExpression();
    label_18:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 40:
      case 63:
        ;
        break;
      default:
        jj_la1[59] = jj_gen;
        break label_18;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 40:
        jj_consume_token(40);
        e2 = UnaryExpression();
                        e = new BinaryOperation("*", e, e2);
        break;
      case 63:
        jj_consume_token(63);
        e2 = UnaryExpression();
                        e = new BinaryOperation("/", e, e2);
        break;
      default:
        jj_la1[60] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  final private Expression UnaryExpression() throws ParseException {
        Expression e;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 64:
      jj_consume_token(64);
      e = PrimaryExpression();
                {if (true) return new UnaryOperation("!", e);}
      break;
    case 61:
      jj_consume_token(61);
      e = PrimaryExpression();
                {if (true) return new UnaryOperation("+", e);}
      break;
    case 62:
      jj_consume_token(62);
      e = PrimaryExpression();
                {if (true) return new UnaryOperation("-", e);}
      break;
    case STR:
    case IS_URI:
    case LANG:
    case IS_IRI:
    case LANGMATCHES:
    case IS_BLANK:
    case IS_LITERAL:
    case DATATYPE:
    case REGEX:
    case BOUND:
    case TRUE:
    case SAME_TERM:
    case FALSE:
    case 46:
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case VAR1:
    case VAR2:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
      e = PrimaryExpression();
                {if (true) return e;}
      break;
    default:
      jj_la1[61] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private Expression PrimaryExpression() throws ParseException {
        Expression e = null;
        Literal l = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 46:
      e = BrackettedExpression();
      break;
    case STR:
    case IS_URI:
    case LANG:
    case IS_IRI:
    case LANGMATCHES:
    case IS_BLANK:
    case IS_LITERAL:
    case DATATYPE:
    case REGEX:
    case BOUND:
    case SAME_TERM:
      e = BuiltInCall();
      break;
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
      e = IRIrefOrFunction();
      break;
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
      l = RDFLiteral();
      break;
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
      l = NumericLiteral();
      break;
    case TRUE:
    case FALSE:
      l = BooleanLiteral();
      break;
    case VAR1:
    case VAR2:
      e = Var();
      break;
    default:
      jj_la1[62] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        if (l != null) {
                {if (true) return new LiteralExpression(l);}
        }
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  final private Expression BrackettedExpression() throws ParseException {
        Expression e;
    jj_consume_token(46);
    e = Expression();
    jj_consume_token(48);
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

  final private BuiltInCall BuiltInCall() throws ParseException {
        List<Expression> args = new ArrayList<Expression>();
        String name;
        Expression e;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STR:
      jj_consume_token(STR);
                name = "STR";
      jj_consume_token(46);
      e = Expression();
                args.add(e);
      jj_consume_token(48);
      break;
    case LANG:
      jj_consume_token(LANG);
                name = "LANG";
      jj_consume_token(46);
      e = Expression();
                args.add(e);
      jj_consume_token(48);
      break;
    case LANGMATCHES:
      jj_consume_token(LANGMATCHES);
                name = "LANGMATCHES";
      jj_consume_token(46);
      e = Expression();
                args.add(e);
      jj_consume_token(47);
      e = Expression();
                args.add(e);
      jj_consume_token(48);
      break;
    case DATATYPE:
      jj_consume_token(DATATYPE);
                name = "DATATYPE";
      jj_consume_token(46);
      e = Expression();
                args.add(e);
      jj_consume_token(48);
      break;
    case BOUND:
      jj_consume_token(BOUND);
                name = "BOUND";
      jj_consume_token(46);
      e = Var();
                args.add(e);
      jj_consume_token(48);
      break;
    case SAME_TERM:
      jj_consume_token(SAME_TERM);
                name = "sameTerm";
      jj_consume_token(46);
      e = Expression();
                args.add(e);
      jj_consume_token(47);
      e = Expression();
                args.add(e);
      jj_consume_token(48);
      break;
    case IS_IRI:
      jj_consume_token(IS_IRI);
                name = "isIRI";
      jj_consume_token(46);
      e = Expression();
                args.add(e);
      jj_consume_token(48);
      break;
    case IS_URI:
      jj_consume_token(IS_URI);
                name = "isURI";
      jj_consume_token(46);
      e = Expression();
                args.add(e);
      jj_consume_token(48);
      break;
    case IS_BLANK:
      jj_consume_token(IS_BLANK);
                name = "isBLANK";
      jj_consume_token(46);
      e = Expression();
                args.add(e);
      jj_consume_token(48);
      break;
    case IS_LITERAL:
      jj_consume_token(IS_LITERAL);
                name = "isLITERAL";
      jj_consume_token(46);
      e = Expression();
                args.add(e);
      jj_consume_token(48);
      break;
    case REGEX:
      e = RegexExpression();
                {if (true) return (BuiltInCall) e;}
      break;
    default:
      jj_la1[63] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return new BuiltInCall(name, args);}
    throw new Error("Missing return statement in function");
  }

  final private BuiltInCall RegexExpression() throws ParseException {
        List<Expression> args = new ArrayList<Expression>();
        Expression e = null;
    jj_consume_token(REGEX);
    jj_consume_token(46);
    e = Expression();
        args.add(e);
    jj_consume_token(47);
    e = Expression();
        args.add(e);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 47:
      jj_consume_token(47);
      e = Expression();
                args.add(e);
      break;
    default:
      jj_la1[64] = jj_gen;
      ;
    }
    jj_consume_token(48);
        {if (true) return new BuiltInCall("REGEX", args);}
    throw new Error("Missing return statement in function");
  }

  final private Expression IRIrefOrFunction() throws ParseException {
        UriRef uriRef;
        List<Expression> args;
    uriRef = IRIref();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 46:
    case NIL:
      args = ArgList();
                {if (true) return new FunctionCall(uriRef, args);}
      break;
    default:
      jj_la1[65] = jj_gen;
      ;
    }
        {if (true) return new UriRefExpression(uriRef);}
    throw new Error("Missing return statement in function");
  }

  final private Literal RDFLiteral() throws ParseException {
        Token t;
        String s;
        UriRef type;
    s = String();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 65:
    case LANGTAG:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LANGTAG:
        t = jj_consume_token(LANGTAG);
                {if (true) return new PlainLiteralImpl(s, new Language(t.image.substring(1)));}
        break;
      case 65:
        jj_consume_token(65);
        type = IRIref();
                        {if (true) return new TypedLiteralImpl(s, type);}
        break;
      default:
        jj_la1[66] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[67] = jj_gen;
      ;
    }
        {if (true) return new PlainLiteralImpl(s);}
    throw new Error("Missing return statement in function");
  }

  final private TypedLiteral NumericLiteral() throws ParseException {
        TypedLiteral l;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
      l = NumericLiteralUnsigned();
      break;
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
      l = NumericLiteralPositive();
      break;
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
      l = NumericLiteralNegative();
      break;
    default:
      jj_la1[68] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return l;}
    throw new Error("Missing return statement in function");
  }

  final private TypedLiteral NumericLiteralUnsigned() throws ParseException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
      t = jj_consume_token(INTEGER);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(Long.valueOf(t.image));}
      break;
    case DECIMAL:
      t = jj_consume_token(DECIMAL);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(Float.valueOf(t.image));}
      break;
    case DOUBLE:
      t = jj_consume_token(DOUBLE);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(Double.valueOf(t.image));}
      break;
    default:
      jj_la1[69] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private TypedLiteral NumericLiteralPositive() throws ParseException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_POSITIVE:
      t = jj_consume_token(INTEGER_POSITIVE);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(Long.valueOf(t.image));}
      break;
    case DECIMAL_POSITIVE:
      t = jj_consume_token(DECIMAL_POSITIVE);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(Float.valueOf(t.image));}
      break;
    case DOUBLE_POSITIVE:
      t = jj_consume_token(DOUBLE_POSITIVE);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(Double.valueOf(t.image));}
      break;
    default:
      jj_la1[70] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private TypedLiteral NumericLiteralNegative() throws ParseException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_NEGATIVE:
      t = jj_consume_token(INTEGER_NEGATIVE);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(Long.valueOf(t.image));}
      break;
    case DECIMAL_NEGATIVE:
      t = jj_consume_token(DECIMAL_NEGATIVE);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(Float.valueOf(t.image));}
      break;
    case DOUBLE_NEGATIVE:
      t = jj_consume_token(DOUBLE_NEGATIVE);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(Double.valueOf(t.image));}
      break;
    default:
      jj_la1[71] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private TypedLiteral BooleanLiteral() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(true);}
      break;
    case FALSE:
      jj_consume_token(FALSE);
                {if (true) return LiteralFactory.getInstance().createTypedLiteral(false);}
      break;
    default:
      jj_la1[72] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private String String() throws ParseException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL1:
      t = jj_consume_token(STRING_LITERAL1);
                {if (true) return unquote(t.image) ;}
      break;
    case STRING_LITERAL2:
      t = jj_consume_token(STRING_LITERAL2);
                {if (true) return unquote(t.image) ;}
      break;
    case STRING_LITERAL_LONG1:
      t = jj_consume_token(STRING_LITERAL_LONG1);
                {if (true) return unTripleQuote(t.image) ;}
      break;
    case STRING_LITERAL_LONG2:
      t = jj_consume_token(STRING_LITERAL_LONG2);
                {if (true) return unTripleQuote(t.image) ;}
      break;
    default:
      jj_la1[73] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private UriRef IRIref() throws ParseException {
        UriRef uriRef;
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
      t = jj_consume_token(IRI_REF);
        {if (true) return createUriRef(unquote(t.image));}
      break;
    case PNAME_NS:
    case PNAME_LN:
      uriRef = PrefixedName();
        {if (true) return uriRef;}
      break;
    default:
      jj_la1[74] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private UriRef PrefixedName() throws ParseException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PNAME_LN:
      t = jj_consume_token(PNAME_LN);
      break;
    case PNAME_NS:
      t = jj_consume_token(PNAME_NS);
      break;
    default:
      jj_la1[75] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return createUriRef(t.image);}
    throw new Error("Missing return statement in function");
  }

  final private ResourceOrVariable BlankNode() throws ParseException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BLANK_NODE_LABEL:
      t = jj_consume_token(BLANK_NODE_LABEL);
        {if (true) return getBNode(t.image);}
      break;
    case ANON:
      jj_consume_token(ANON);
        {if (true) return getNewBNode();}
      break;
    default:
      jj_la1[76] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  /** Generated Token Manager. */
  public JavaCCGeneratedQueryParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[77];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static private int[] jj_la1_3;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
      jj_la1_init_2();
      jj_la1_init_3();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x40820100,0x200,0x10000,0x80000000,0x80000000,0x0,0x0,0x1000,0x1000,0x0,0x0,0x1000,0x2000000,0x1000,0x80000,0x2000000,0x400,0x1040000,0x1000000,0x40000,0x1040000,0x3860c000,0x0,0x3860c000,0x3860c000,0x0,0x102000,0x102000,0x0,0x0,0x0,0x0,0x102000,0x4000000,0x3860c000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3860c000,0x3860c000,0x3860c000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0x0,0x0,0x0,0x8,0x8,0x0,0x100,0x0,0x0,0x0,0x100,0x0,0x800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4656,0x600,0x4056,0x4656,0x840a0,0x801,0x801,0x1000,0x840a0,0x840a0,0x1000,0x800,0x0,0x4056,0x8000,0x4000,0x840a0,0x840a0,0x1000,0x840a0,0x20000,0x40000,0x40000,0x8000,0x40000,0x84000,0x840a0,0x840a0,0xa0,0x0,0x0,0xa0,0x200000,0x400000,0x1f800000,0x1f800000,0x60000000,0x60000000,0x80000100,0x80000100,0x600040f6,0x40f6,0x56,0x8000,0x4000,0x0,0x0,0x0,0x0,0x0,0x0,0xa0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_init_2() {
      jj_la1_2 = new int[] {0x0,0x0,0x0,0x0,0x0,0xc0,0xc0,0x0,0x0,0xdc,0xdc,0x0,0x0,0x0,0x1c,0x0,0x0,0x0,0x0,0x0,0x0,0xdc,0x0,0xdc,0xdc,0x2bdff0fc,0x0,0x0,0x0,0x2bdff0fc,0x2bdff0fc,0x0,0x0,0x0,0x1c,0x0,0x8000000,0x2bdff0fc,0x2bdff0fc,0x0,0x2bdff0fc,0x0,0xdc,0xdc,0x0,0xdc,0x0,0x2bdff0fc,0x2bdff0fc,0x2bdff0fc,0xdc,0xc0,0x2bdff03c,0x0,0x0,0x0,0x0,0x1f8000,0x1f8000,0x0,0x0,0x3dff0dd,0x3dff0dc,0x0,0x0,0x8000000,0x102,0x102,0x1ff000,0x7000,0x38000,0x1c0000,0x0,0x3c00000,0x1c,0x18,0x20000020,};
   }
   private static void jj_la1_init_3() {
      jj_la1_3 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }

  /** Constructor with InputStream. */
  public JavaCCGeneratedQueryParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public JavaCCGeneratedQueryParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new JavaCCGeneratedQueryParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
  }

  /** Constructor. */
  public JavaCCGeneratedQueryParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new JavaCCGeneratedQueryParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
  }

  /** Constructor with generated Token Manager. */
  public JavaCCGeneratedQueryParser(JavaCCGeneratedQueryParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(JavaCCGeneratedQueryParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List jj_expentries = new java.util.ArrayList();
  private int[] jj_expentry;
  private int jj_kind = -1;

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[100];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 77; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 100; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

}
